@echo off
if "%~1"=="" (
	echo usage: %0 user_common_name [output_template]
	exit /b 1
)

setlocal enabledelayedexpansion 

call vars.bat

REM     
if exist %KEY_DIR%\%1.crt (
	for /f "tokens=*" %%i in ('openssl x509 -enddate -noout -in %KEY_DIR%\%1.crt') do set "USER_CERT_DATE_FULL=%%i"
	for /f "tokens=*" %%i in ('openssl x509 -enddate -noout -in %KEY_DIR%\single-ca.crt') do set "CA_CERT_DATE_FULL=%%i"
) else if exist "%KEY_DIR%.previous\%1.crt" (
	for /f "tokens=*" %%i in ('openssl x509 -enddate -noout -in %KEY_DIR%.previous\%1.crt') do set "USER_CERT_DATE_FULL=%%i"
	for /f "tokens=*" %%i in ('openssl x509 -enddate -noout -in %KEY_DIR%.previous\single-ca.crt') do set "CA_CERT_DATE_FULL=%%i"
) else (
	echo File "%~1.crt" not found
	endlocal & exit /b 1
)

REM    
set USER_CERT_DATE=%USER_CERT_DATE_FULL:~9%
set CA_CERT_DATE=%CA_CERT_DATE_FULL:~9%

REM   
for /f "tokens=1,2,4 delims= " %%a in ('echo %USER_CERT_DATE%') do (
    set "USER_MONTH_STR=%%a"
    set "USER_DAY=%%b"
    set "USER_YEAR=%%c"
)
for /f "tokens=1,2,4 delims= " %%a in ('echo %CA_CERT_DATE%') do (
    set "CA_MONTH_STR=%%a"
    set "CA_DAY=%%b"
    set "CA_YEAR=%%c"
)

REM        
call :convert_month !USER_MONTH_STR! USER_MONTH
call :convert_month !CA_MONTH_STR! CA_MONTH

REM    
if %USER_DAY% LSS 10 (set USER_DAY=0%USER_DAY%)
if %CA_DAY% LSS 10 (set CA_DAY=0%CA_DAY%)

REM  
if %USER_YEAR%%USER_MONTH%%USER_DAY% LSS %CA_YEAR%%CA_MONTH%%CA_DAY% (
	set YEAR=%USER_YEAR%
	set MONTH=%USER_MONTH%
	set MONTH_STR=%USER_MONTH_STR%
	set DAY=%USER_DAY%
	set "ORIGINAL_DATE_STRING=%USER_CERT_DATE_FULL%"
) else (
	set YEAR=%CA_YEAR%
	set MONTH=%CA_MONTH%
	set MONTH_STR=%CA_MONTH_STR%
	set DAY=%CA_DAY%
	set "ORIGINAL_DATE_STRING=%CA_CERT_DATE_FULL%"
)

REM       
if "%~2"=="" (
	echo %~1 is to expire on %YEAR%-%MONTH%-%DAY%
) else if "%~2"=="original" (
	echo %ORIGINAL_DATE_STRING%
) else (
	set "TEMPLATE=%~2"
	set TEMPLATE=!TEMPLATE:%%o=%1!
	set TEMPLATE=!TEMPLATE:%%Y=%YEAR%!
	set TEMPLATE=!TEMPLATE:%%b=%MONTH_STR%!
	set TEMPLATE=!TEMPLATE:%%m=%MONTH%!
	set TEMPLATE=!TEMPLATE:%%d=%DAY%!
	echo !TEMPLATE!
)

REM      ,     
if "%~1"=="ca" (
	if %MONTH% LSS "04" (
		set /a YEAR_CHANGE=%YEAR%-2
		set /a MONTH_CHANGE=%MONTH%+9
	) else (
		set /a YEAR_CHANGE=%YEAR%-1
		set /a MONTH_CHANGE=%MONTH%-3
	)
	if !MONTH_CHANGE! LSS 10 (set MONTH_CHANGE=0!MONTH_CHANGE!)
	echo You should change it ^(run change-ca.bat^) before !YEAR_CHANGE!-!MONTH_CHANGE!-!DAY!
)

endlocal

exit /b 0


:convert_month
REM        
REM  : 
REM   %1 -    
REM   %2 -     
setlocal
set "month=%1"
set output_var=%2

REM    
if /i "%month%"=="Jan" set "month_num=01"
if /i "%month%"=="Feb" set "month_num=02"
if /i "%month%"=="Mar" set "month_num=03"
if /i "%month%"=="Apr" set "month_num=04"
if /i "%month%"=="May" set "month_num=05"
if /i "%month%"=="Jun" set "month_num=06"
if /i "%month%"=="Jul" set "month_num=07"
if /i "%month%"=="Aug" set "month_num=08"
if /i "%month%"=="Sep" set "month_num=09"
if /i "%month%"=="Oct" set "month_num=10"
if /i "%month%"=="Nov" set "month_num=11"
if /i "%month%"=="Dec" set "month_num=12"

endlocal & set "%output_var%=%month_num%"
